<?php

class leurlrewrite extends Module {
	public function __construct()
	{
		$this->name = 'leurlrewrite';
		$this->tab = 'seo';
		$this->version = '1.0';
		$this->need_instance = 0;
		$this->author = 'LitExtension';

		parent::__construct();

		$this->displayName = $this->l('LitExtension Url Plugin');
		$this->description = $this->l('Preserve old Urls of Products and Categories after migration and keep your current SEO ranking');
	}
	
	public function install(){
        if (parent::install() == false ||
                !$this->_installDatabase()) {
            return false;
        }
        return true;
    }

    public function uninstall(){
        if (parent::uninstall() == false ||
                !$this->_uninstallDatabase()) {
            return false;
        }
        return true;
    }
	
	protected function _installDatabase() {
        $queries = array(
            "CREATE TABLE IF NOT EXISTS " . _DB_PREFIX_ . "lecm_rewrite (
            `id_url` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
            `id_src` INT(11),
            `link_rewrite` VARCHAR(255),
            `id_desc` INT(11),
            `type` VARCHAR(8),
            `lang_code` VARCHAR(2),
            PRIMARY KEY  (`id_url`),
            INDEX lecm_index_rewrite(`id_src`, `id_desc`, `type`, `link_rewrite`, `lang_code`)
            ) ENGINE=" . _MYSQL_ENGINE_ . " DEFAULT CHARSET=utf8",
        );
        $result = true;
        foreach ($queries as $query) {
            if (!Db::getInstance()->execute($query)) {
                $result = false;
            }
        }
        return $result;
    }
	
	protected function _uninstallDatabase() {
        $queries = array(
            "DROP TABLE IF EXISTS " . _DB_PREFIX_ . "lecm_rewrite",
        );
        $result = true;
        foreach ($queries as $query) {
            if (!Db::getInstance()->execute($query)) {
                $result = false;
            }
        }
        return $result;
    }
}